--- /data/indico/htdocs/js/indico/pack/Core.js.pack_orig0981	2012-06-01 14:05:53.665904928 +0200
+++ /data/indico/htdocs/js/indico/pack/Core.js.pack	2012-05-04 15:06:27.653904857 +0200
@@ -298,3 +298,3 @@
 killProgress();}else{if(progress)
-killProgress();IndicoUtil.errorReport(error);}});},_manageAllConectedUserList:function(){},_personName:function(user){if(user._type=="Group"||user._type=="CERNGroup"){var fullName=user.name;}else{if(user.pending){var fullName=$T('Non-registered user');}else{var fullName=user.familyName.toUpperCase()+(user.firstName?(', '+user.firstName):'');}}
+killProgress();IndicoUtil.errorReport(error);}});},_manageAllConectedUserList:function(){},_personName:function(user){if(user._type=="Group"||user._type=="CERNGroup"||user._type=="LDAPGroup"/*1*/){var fullName=user.name;}else{if(user.pending){var fullName=$T('Non-registered user');}else{var fullName=user.familyName.toUpperCase()+(user.firstName?(', '+user.firstName):'');}}
 if(this.nameOptions['title']&&user.title){fullName=user.title+' '+fullName;}
@@ -302,3 +302,3 @@
 if((this.nameOptions['email']||user.pending)&&user.email){fullName+='<small> ('+user.email+')</small>';}
-return fullName;},_component_order:['remove','edit','favorite','menu','arrows'],_components:{menu:function(user){var self=this;if(!user.pending&&user._type!="Group"&&user._type!="CERNGroup"){var optionsMenuSpan=$('<span/>').css('float','right').hover(function(){$(this).addClass('mouseover');},function(){$(this).removeClass('mouseover');});var optionsMenuLink=$('<a/>').attr({id:user.id,'class':'dropDownMenu fakeLink',style:'margin-left:15px; margin-right:15px'}).append($T('More')).click(function(event){self.userOptions.onMenu.call(self,this,user);});optionsMenuSpan.append(optionsMenuLink);return optionsMenuSpan;}},favorite:function(user){if(user._type=="Avatar"){return $('<span/>').css({padding:'3px','float':'right'}).html(new ToggleFavouriteButton(user,{},IndicoGlobalVars['userData']['favorite-user-ids'][user.id]).draw().dom);}},remove:function(user){var self=this;return $('<img/>').attr({src:imageSrc("remove"),alt:$T('Remove ')+self.userCaption,title:$T('Remove this ')+self.userCaption+$T(' from the list'),'class':'UIRowButton2',style:"margin-right:10px; float:right; cursor:pointer;"}).click(function(event){self.userOptions.onRemove.call(self,user);});},edit:function(user,callback){var self=this;return $('<img />').attr({src:imageSrc("edit"),alt:$T('Edit ')+this.userCaption,title:$T('Edit this ')+this.userCaption,'class':'UIRowButton2',style:'float: right; cursor: pointer;'}).click(function(event){self.userOptions.onEdit.call(self,user);});},arrows:function(user,callback_up,callback_down){var self=this;var arrow=function(direction,title){return $('<img/>').attr({src:imageSrc("arrow_"+direction),'alt':title,'title':title,style:'padding-top: 6px; float: left; cursor: pointer'});};return $('<div/>').append(arrow('up',$T('Move up')).click(function(event){self.userOptions.onArrowUp.call(self,user);}),arrow('down',$T('Move down')).click(function(event){self.userOptions.onArrowDown.call(self,user);}));}},onEdit:function(userData,all){var self=this;var user=$O(userData);var editUserPopup=new UserDataPopup($T('Edit ')+self.userCaption+$T(' data'),user,function(newData){if(editUserPopup.parameterManager.check()){if(!all)
+return fullName;},_component_order:['remove','edit','favorite','menu','arrows'],_components:{menu:function(user){var self=this;if(!user.pending&&user._type!="Group"&&user._type!="CERNGroup"&&user._type!="LDAPGroup"){var optionsMenuSpan=$('<span/>').css('float','right').hover(function(){$(this).addClass('mouseover');},function(){$(this).removeClass('mouseover');});var optionsMenuLink=$('<a/>').attr({id:user.id,'class':'dropDownMenu fakeLink',style:'margin-left:15px; margin-right:15px'}).append($T('More')).click(function(event){self.userOptions.onMenu.call(self,this,user);});optionsMenuSpan.append(optionsMenuLink);return optionsMenuSpan;}},favorite:function(user){if(user._type=="Avatar"){return $('<span/>').css({padding:'3px','float':'right'}).html(new ToggleFavouriteButton(user,{},IndicoGlobalVars['userData']['favorite-user-ids'][user.id]).draw().dom);}},remove:function(user){var self=this;return $('<img/>').attr({src:imageSrc("remove"),alt:$T('Remove ')+self.userCaption,title:$T('Remove this ')+self.userCaption+$T(' from the list'),'class':'UIRowButton2',style:"margin-right:10px; float:right; cursor:pointer;"}).click(function(event){self.userOptions.onRemove.call(self,user);});},edit:function(user,callback){var self=this;return $('<img />').attr({src:imageSrc("edit"),alt:$T('Edit ')+this.userCaption,title:$T('Edit this ')+this.userCaption,'class':'UIRowButton2',style:'float: right; cursor: pointer;'}).click(function(event){self.userOptions.onEdit.call(self,user);});},arrows:function(user,callback_up,callback_down){var self=this;var arrow=function(direction,title){return $('<img/>').attr({src:imageSrc("arrow_"+direction),'alt':title,'title':title,style:'padding-top: 6px; float: left; cursor: pointer'});};return $('<div/>').append(arrow('up',$T('Move up')).click(function(event){self.userOptions.onArrowUp.call(self,user);}),arrow('down',$T('Move down')).click(function(event){self.userOptions.onArrowDown.call(self,user);}));}},onEdit:function(userData,all){var self=this;var user=$O(userData);var editUserPopup=new UserDataPopup($T('Edit ')+self.userCaption+$T(' data'),user,function(newData){if(editUserPopup.parameterManager.check()){if(!all)
 self._manageUserList(self.methods["edit"],self._getEditParams(newData));else